package Gamefile
{
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.filters.GlowFilter;
   
   public class Background
   {
       
      
      public var bgNum:int;
      
      public var _bg_:MovieClip;
      
      private var btnSprite:MovieClip;
      
      public var _bgBtn_:MovieClip;
      
      private var bgBtnFilter:GlowFilter;
      
      public var currentlyBGNum:int;
      
      public function Background(param1:MovieClip, param2:MovieClip)
      {
         super();
         initBackground(param1,param2);
      }
      
      public function chooseBGMian() : *
      {
         SoundsManager.playSound("_GameMouseDown_");
         ++bgNum;
         currentlyBGNum = bgNum;
         _bg_.gotoAndStop(bgNum);
         _bgBtn_.gotoAndStop(bgNum);
         if(bgNum == 5)
         {
            bgNum = 0;
         }
      }
      
      public function intoBgNum() : int
      {
         return currentlyBGNum;
      }
      
      public function getBgNum(param1:int) : *
      {
         currentlyBGNum = param1;
         bgNum = param1;
      }
      
      private function initElement() : *
      {
         _bgBtn_ = btnSprite.getChildByName("BgBtn") as MovieClip;
      }
      
      private function initProperty() : *
      {
         bgBtnFilter = new GlowFilter(16777215,1,6,6,10,1,false,false);
         bgNum = 1;
         currentlyBGNum = 1;
         _bgBtn_.gotoAndStop(1);
      }
      
      public function delEvent() : *
      {
         _bgBtn_.removeEventListener(MouseEvent.CLICK,chooseBG);
         _bgBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _bgBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
      }
      
      private function chooseBG(param1:MouseEvent) : *
      {
         chooseBGMian();
      }
      
      private function initBackground(param1:MovieClip, param2:MovieClip) : *
      {
         _bg_ = param1;
         btnSprite = param2;
         initElement();
         initEvent();
         initProperty();
         _bg_.gotoAndStop(bgNum);
      }
      
      private function mouseIsOver(param1:MouseEvent) : *
      {
         SoundsManager.playSound("_GameMouseOver_");
         showBgBtnFilters();
         _bgBtn_.dispatchEvent(new Event("mouseIsOver",true));
      }
      
      private function mouseIsOut(param1:MouseEvent) : *
      {
         delBgBtnFilters();
         _bgBtn_.dispatchEvent(new Event("mouseIsOut",true));
      }
      
      public function delBgBtnFilters() : *
      {
         _bgBtn_.filters = [];
      }
      
      private function initEvent() : *
      {
         _bgBtn_.addEventListener(MouseEvent.CLICK,chooseBG);
         _bgBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _bgBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
      }
      
      public function outputCurrentlyBGNum() : int
      {
         return bgNum;
      }
      
      public function showBgBtnFilters() : *
      {
         _bgBtn_.filters = [bgBtnFilter];
      }
   }
}
