package Gamefile
{
   import flash.display.MovieClip;
   import flash.events.MouseEvent;
   import flash.ui.Mouse;
   
   public class MouseControl
   {
       
      
      private var PARENT:MovieClip;
      
      public var _mouse_:MovieClip;
      
      public function MouseControl(param1:MovieClip)
      {
         super();
         initMouseControl(param1);
      }
      
      private function mouseIsMove(param1:MouseEvent) : *
      {
         _mouse_.x = PARENT.mouseX;
         _mouse_.y = PARENT.mouseY;
      }
      
      private function mouseIsUp(param1:MouseEvent) : *
      {
         _mouse_.gotoAndStop(1);
      }
      
      public function delMouseControl() : *
      {
         delEvent();
         PARENT.removeChild(_mouse_);
      }
      
      public function mouseShow() : *
      {
         _mouse_.visible = true;
      }
      
      private function initProperty() : *
      {
         Mouse.hide();
         _mouse_.mouseEnabled = false;
         _mouse_.mouseChildren = false;
         _mouse_.visible = false;
         _mouse_.gotoAndStop(1);
      }
      
      public function initMouseControl(param1:MovieClip) : *
      {
         PARENT = param1;
         initElement();
         initEvent();
         initProperty();
      }
      
      public function createMouse(param1:MovieClip, param2:int, param3:int) : *
      {
         _mouse_ = new _Mouse_();
         param1.addChild(_mouse_);
         _mouse_.x = param2;
         _mouse_.y = param3;
      }
      
      public function initEvent() : *
      {
         PARENT.addEventListener(MouseEvent.MOUSE_MOVE,mouseIsMove);
         PARENT.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         PARENT.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
      }
      
      private function initElement() : *
      {
         _mouse_ = new _Mouse_();
         PARENT.addChild(_mouse_);
      }
      
      public function mouseHide() : *
      {
         _mouse_.visible = false;
      }
      
      public function delEvent() : *
      {
         PARENT.removeEventListener(MouseEvent.MOUSE_MOVE,mouseIsMove);
         PARENT.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
      }
      
      private function mouseIsDown(param1:MouseEvent) : *
      {
         _mouse_.gotoAndStop(2);
      }
      
      public function delMouse() : *
      {
         _mouse_.parent.removeChild(_mouse_);
      }
      
      private function mouseIsOver(param1:MouseEvent) : *
      {
         mouseShow();
      }
      
      private function mouseIsOut(param1:MouseEvent) : *
      {
         mouseHide();
      }
   }
}
