package Gamefile
{
   import flash.display.MovieClip;
   
   public class DrawTool
   {
       
      
      private var curveLineColor:uint;
      
      public var curveMC:MovieClip;
      
      public const operateType:int = 4;
      
      private var PARENT:MovieClip;
      
      public var curveLineArr:Array;
      
      public function DrawTool(param1:MovieClip)
      {
         super();
         initDrawTool(param1);
      }
      
      public function setCurveLineColor(param1:uint) : *
      {
         curveLineColor = param1;
         if(curveMC != null)
         {
            curveMC.graphics.lineStyle(7,curveLineColor,1);
         }
      }
      
      public function startDrawCurveLine(param1:MovieClip, param2:int, param3:int, param4:uint) : *
      {
         curveMC = new MovieClip();
         param1.addChild(curveMC);
         setCurveLineColor(param4);
         curveMC.graphics.moveTo(param2,param3);
      }
      
      public function drawCurveLine(param1:int, param2:int, param3:Number, param4:Number) : *
      {
         SoundsManager.playSound("_SnakeMove_S_");
         curveMC.graphics.curveTo(param1,param2,param3,param4);
      }
      
      public function hideCurveLine() : *
      {
         var _loc1_:int = 0;
         _loc1_ = 0;
         while(_loc1_ < curveLineArr.length)
         {
            if(curveLineArr[_loc1_] != "end")
            {
               curveLineArr[_loc1_].visible = false;
            }
            _loc1_++;
         }
      }
      
      public function clearDraw() : *
      {
         PARENT.graphics.clear();
      }
      
      public function initDrawTool(param1:MovieClip) : *
      {
         PARENT = param1;
         initProperty();
      }
      
      public function pushEndFlag(param1:Boolean) : *
      {
         if(param1 == false)
         {
            curveLineArr.push(curveMC);
            curveLineArr.push("end");
         }
      }
      
      public function showCurveLine() : *
      {
         var _loc1_:int = 0;
         _loc1_ = 0;
         while(_loc1_ < curveLineArr.length)
         {
            if(curveLineArr[_loc1_] != "end")
            {
               curveLineArr[_loc1_].visible = true;
            }
            _loc1_++;
         }
      }
      
      public function startDrawLine(param1:int, param2:int) : *
      {
         PARENT.graphics.lineStyle(1,255,1);
         PARENT.graphics.moveTo(param1,param2);
      }
      
      private function initProperty() : *
      {
         curveLineArr = new Array();
         curveLineColor = 16737380;
      }
      
      public function drawLine(param1:int, param2:int) : *
      {
         PARENT.graphics.lineTo(param1,param2);
      }
   }
}
