package Gamefile
{
   import flash.display.MovieClip;
   import flash.events.Event;
   
   public class Game
   {
       
      
      private var gameChina:GameChina;
      
      private var gameStart:GameStart;
      
      private var ROOT:MovieClip;
      
      private var mouseControl:MouseControl;
      
      private var main:Main;
      
      private var loading:Loading;
      
      public function Game(param1:MovieClip)
      {
         super();
         initGame(param1);
      }
      
      private function advance(param1:MovieClip) : *
      {
         param1.gotoAndStop(3);
         param1.gotoAndStop(1);
      }
      
      private function showGameChina(param1:Event) : *
      {
         delLoading();
         gameChina = new GameChina(ROOT);
      }
      
      private function delGameStart() : *
      {
         ROOT.removeEventListener("showMain",showMain);
         mouseControl.delMouseControl();
         gameStart = null;
      }
      
      private function showGameStart(param1:Event) : *
      {
         if(Language.mode == 2)
         {
            trace("delCHINAGAME");
            gameChina.del();
            gameChina = null;
         }
         else
         {
            delLoading();
         }
         showGameStartMain();
      }
      
      private function showMain(param1:Event) : *
      {
         delGameStart();
         main = new Main(ROOT);
         main.helpAutoEnd = true;
         ROOT.addEventListener("delMain",delMain);
      }
      
      private function delMain(param1:Event) : *
      {
         main.delMain();
         main = null;
         ROOT.removeEventListener("delMain",delMain);
         showGameStartMain();
      }
      
      private function initGame(param1:MovieClip) : *
      {
         ROOT = param1;
         initEvent();
         showLoading();
      }
      
      private function initEvent() : *
      {
         ROOT.addEventListener("showGameStart",showGameStart);
         ROOT.addEventListener("showGameChina",showGameChina);
      }
      
      private function showGameStartMain() : *
      {
         gameStart = new GameStart(ROOT);
         mouseControl = new MouseControl(ROOT);
         ROOT.addEventListener("showMain",showMain);
         ROOT.addEventListener("showMainHelp",showMainHelp);
      }
      
      private function delLoading() : *
      {
         loading = null;
         advance(ROOT);
      }
      
      private function showMainHelp(param1:Event) : *
      {
         delGameStart();
         main = new Main(ROOT);
         main.helpAutoEnd = false;
         ROOT.addEventListener("delMain",delMain);
         main.startHelpMain(true);
      }
      
      private function showLoading() : *
      {
         loading = new Loading(ROOT);
      }
   }
}
