package Gamefile
{
   import flash.display.MovieClip;
   import flash.display.SimpleButton;
   import flash.display.Sprite;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.geom.Rectangle;
   import flash.printing.PrintJob;
   
   public class PrintTool
   {
       
      
      private var printMack:MovieClip;
      
      private var PARENT:MovieClip;
      
      private var printJob:PrintJob;
      
      private var _printBtn_:SimpleButton;
      
      public function PrintTool(param1:MovieClip)
      {
         super();
         initPrintTool(param1);
      }
      
      private function mouseIsOver(param1:MouseEvent) : *
      {
         SoundsManager.playSound("_GameMouseOver_");
         _printBtn_.dispatchEvent(new Event("mouseIsOver",true));
      }
      
      public function createMask(param1:MovieClip, param2:MovieClip, param3:int, param4:int) : *
      {
         printMack = new _PrintMask_();
         param1.addChild(printMack);
         printMack.x = param3;
         printMack.y = param4;
         param2.mask = printMack;
      }
      
      private function initElement() : *
      {
         _printBtn_ = PARENT.getChildByName("PrintBtn") as SimpleButton;
      }
      
      private function initPrintTool(param1:MovieClip) : *
      {
         PARENT = param1;
         initElement();
         initEvent();
      }
      
      public function delEvent() : *
      {
         _printBtn_.removeEventListener(MouseEvent.CLICK,printing);
         _printBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _printBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
      }
      
      public function delMask(param1:MovieClip) : *
      {
         printMack.parent.removeChild(printMack);
         param1.mask = null;
      }
      
      private function initEvent() : *
      {
         _printBtn_.addEventListener(MouseEvent.CLICK,printing);
         _printBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _printBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
      }
      
      public function printOpus(param1:Sprite, param2:Rectangle) : *
      {
         var _o:Sprite = param1;
         var _rect:Rectangle = param2;
         printJob = new PrintJob();
         printJob.start();
         try
         {
            printJob.addPage(_o,_rect);
         }
         catch(e:Error)
         {
            trace("print error");
         }
         printJob.send();
      }
      
      private function printing(param1:MouseEvent) : *
      {
         SoundsManager.playSound("_GameMouseDown_");
         PARENT.dispatchEvent(new Event("printing",true));
      }
      
      private function mouseIsOut(param1:MouseEvent) : *
      {
         _printBtn_.dispatchEvent(new Event("mouseIsOut",true));
      }
   }
}
