package Gamefile
{
   import flash.display.MovieClip;
   import flash.display.SimpleButton;
   import flash.events.Event;
   import flash.events.MouseEvent;
   
   public class Repeal
   {
       
      
      public var repealArr:Array;
      
      private var repealMCY:int;
      
      public var _repealBtn_:SimpleButton;
      
      private var repealMCX:int;
      
      private var repealMC:MovieClip;
      
      public var _repealAllBtn_:SimpleButton;
      
      private var PARENT:MovieClip;
      
      public function Repeal(param1:MovieClip)
      {
         super();
         initRepeal(param1);
      }
      
      private function initRepeal(param1:MovieClip) : *
      {
         PARENT = param1;
         initElement();
         initEvent();
         initProperty();
      }
      
      private function initProperty() : *
      {
         repealArr = new Array();
         repealMCX = -18;
         repealMCY = 15;
      }
      
      public function showRepealMC(param1:MovieClip) : *
      {
         PARENT.mouseChildren = false;
         repealMC = new _RepealAllMC_();
         param1.addChild(repealMC);
         repealMC.x = repealMCX;
         repealMC.y = repealMCY;
         repealMC.addEventListener(Event.ENTER_FRAME,delRepealMC);
      }
      
      public function repealAllObj(param1:Array) : Array
      {
         var _loc2_:int = 0;
         _loc2_ = 0;
         while(_loc2_ < param1.length)
         {
            if(param1[_loc2_] != "end")
            {
               param1[_loc2_].parent.removeChild(param1[_loc2_]);
            }
            _loc2_++;
         }
         return [];
      }
      
      public function repealOperateType() : int
      {
         return repealArr[repealArr.length - 1];
      }
      
      private function initElement() : *
      {
         _repealBtn_ = PARENT.getChildByName("RepealBtn") as SimpleButton;
         _repealAllBtn_ = PARENT.getChildByName("RepealAllBtn") as SimpleButton;
      }
      
      public function delEvent() : *
      {
         _repealBtn_.removeEventListener(MouseEvent.CLICK,repealOperate);
         _repealAllBtn_.removeEventListener(MouseEvent.CLICK,repealAll);
         _repealBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _repealBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _repealAllBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _repealAllBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
      }
      
      public function noteInformation(param1:int) : *
      {
         repealArr.push(param1);
      }
      
      private function delRepealMC(param1:Event) : *
      {
         delRepealMCMain();
      }
      
      public function repealAll(param1:MouseEvent) : *
      {
         SoundsManager.playSound("_Elephant_S_");
         PARENT.dispatchEvent(new Event("repealAll",true));
      }
      
      private function mouseIsOut(param1:MouseEvent) : *
      {
         PARENT.dispatchEvent(new Event("mouseIsOut",true));
      }
      
      public function delInformation() : *
      {
         repealArr.pop();
      }
      
      private function mouseIsOver(param1:MouseEvent) : *
      {
         SoundsManager.playSound("_GameMouseOver_");
         PARENT.dispatchEvent(new Event("mouseIsOver",true));
      }
      
      public function delRepealMCEvent() : *
      {
         if(repealMC != null)
         {
            repealMC.addEventListener(Event.ENTER_FRAME,delRepealMC);
            repealMC = null;
         }
      }
      
      private function initEvent() : *
      {
         _repealBtn_.addEventListener(MouseEvent.CLICK,repealOperate);
         _repealAllBtn_.addEventListener(MouseEvent.CLICK,repealAll);
         _repealBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _repealBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _repealAllBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _repealAllBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
      }
      
      public function repealObj(param1:Array) : Array
      {
         var _loc2_:int = 0;
         _loc2_ = 1;
         while(param1.length - 1 >= 0)
         {
            if(param1[param1.length - 1] == "end" && _loc2_ == 1)
            {
               param1.pop();
               _loc2_ = 2;
            }
            else
            {
               if(param1[param1.length - 1] == "end")
               {
                  break;
               }
               param1[param1.length - 1].parent.removeChild(param1[param1.length - 1]);
               param1.pop();
            }
         }
         return param1;
      }
      
      public function delRepealMCMain() : *
      {
         if(repealMC != null)
         {
            if(repealMC.currentFrame == repealMC.totalFrames)
            {
               trace("this1");
               repealMC.removeEventListener(Event.ENTER_FRAME,delRepealMC);
               trace("this2");
               repealMC.parent.removeChild(repealMC);
               trace("this3");
               repealMC = null;
               PARENT.mouseChildren = true;
            }
         }
      }
      
      private function repealOperate(param1:MouseEvent) : *
      {
         SoundsManager.playSound("_Squirrel_S_");
         PARENT.dispatchEvent(new Event("repealOperate",true));
      }
   }
}
